# InformationFilter

## Introduction and Overview

This is a basic implementation of the information filter.

Copyright 2015 Roger R Labbe Jr.

FilterPy library. http://github.com/rlabbe/filterpy

Documentation at: https://filterpy.readthedocs.org

Supporting book at: https://github.com/rlabbe/Kalman-and-Bayesian-Filters-in-Python

This is licensed under an MIT license. See the readme.MD file for more information.

class filterpy.kalman.InformationFilter(dim_x, dim_z, dim_u=0, compute_log_likelihood=True)

  Create a linear Information filter. Information filters compute the inverse of the Kalman filter, allowing you to easily denote having no information at initialization.

  You are responsible for setting the various state variables to reasonable values; the defaults below will not give you a functional filter.

  Parameters:
    dim_x int

      Number of state variables for the filter. For example, if you are tracking the position and velocity of an object in two dimensions, dim_x would be 4.

      This is used to set the default size of P, Q, and u

    dim_z int

      Number of of measurement inputs. For example, if the sensor provides you with position in (x,y), dim_z would be 2.

    dim_u int (optional)

      size of the control input, if it is being used. Default value of 0 indicates it is not used.

    self.compute_log_likelihood = compute_log_likelihood
    self.log_likelihood = math.log(sys.float_info.min)
  Attributes:
    x numpy.array(dim_x, 1)

      State estimate vector

    P_inv numpy.array(dim_x, dim_x)

      inverse state covariance matrix

    x_prior numpy.array(dim_x, 1)

      Prior (predicted) state estimate. The *_prior and *_post attributes are for convienence; they store the prior and posterior of the current epoch. Read Only.

    P_inv_prior numpy.array(dim_x, dim_x)

      Inverse prior (predicted) state covariance matrix. Read Only.

    x_post numpy.array(dim_x, 1)

      Posterior (updated) state estimate. Read Only.

    P_inv_post numpy.array(dim_x, dim_x)

      Inverse posterior (updated) state covariance matrix. Read Only.

    z ndarray

      Last measurement used in update(). Read only.

    R_inv numpy.array(dim_z, dim_z)

      inverse of measurement noise matrix

    Q numpy.array(dim_x, dim_x)

      Process noise matrix

    H numpy.array(dim_z, dim_x)

      Measurement function

    y numpy.array

      Residual of the update step. Read only.

    K numpy.array(dim_x, dim_z)

      Kalman gain of the update step. Read only.

    S numpy.array

      Systen uncertaintly projected to measurement space. Read only.

    log_likelihood float

      log-likelihood of the last measurement. Read only.

    likelihood float

      likelihood of last measurment. Read only.

      Computed from the log-likelihood. The log-likelihood can be very small, meaning a large negative value such as -28000. Taking the exp() of that results in 0.0, which can break typical algorithms which multiply by this value, so by default we always return a number >= sys.float_info.min.

    inv function, default numpy.linalg.inv

      If you prefer another inverse function, such as the Moore-Penrose pseudo inverse, set it to that instead: kf.inv = np.linalg.pinv

  Examples

  See my book Kalman and Bayesian Filters in Python https://github.com/rlabbe/Kalman-and-Bayesian-Filters-in-Python

  __init__(dim_x, dim_z, dim_u=0, compute_log_likelihood=True)
  update(z, R_inv=None)

    Add a new measurement (z) to the kalman filter. If z is None, nothing is changed.

    Parameters:
      z np.array

        measurement for this update.

      R np.array, scalar, or None

        Optionally provide R to override the measurement noise for this one call, otherwise self.R will be used.

  predict(u=0)

    Predict next position.

    Parameters:
      u ndarray

        Optional control vector. If non-zero, it is multiplied by B to create the control input into the system.

  batch_filter(zs, Rs=None, update_first=False, saver=None)

    Batch processes a sequences of measurements.

    Parameters:
      zs list-like

        list of measurements at each time step self.dt Missing measurements must be represented by ‘None’.

      Rs list-like, optional

        optional list of values to use for the measurement error covariance; a value of None in any position will cause the filter to use self.R for that time step.

      update_first bool, optional,

        controls whether the order of operations is update followed by predict, or predict followed by update. Default is predict->update.

      saver filterpy.common.Saver, optional

        filterpy.common.Saver object. If provided, saver.save() will be called after every epoch

    Returns:
      means: np.array((n,dim_x,1))

        array of the state for each time step. Each entry is an np.array. In other words means[k,:] is the state at step k.

      covariance: np.array((n,dim_x,dim_x))

        array of the covariances for each time step. In other words covariance[k,:,:] is the covariance at step k.

  property F

    State Transition matrix

  property P

    State covariance matrix